; dotsphere
;								TAS / jun1992


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$30000	$30e00
*  screens			$50000	$60000
*  matrix area			$60000	$80000

DEMOSTARTUP = 0

 INCLUDE chipmap.inc
 ORG $30000
 LOAD $30000
sintabel = $27800
>EXTERN 'DF0:sin1024.data',sintabel


width = 40-12
size  = width*217*2
screen1		= $66000
screen2 	= screen1+size
screen3 	= screen2+size
matrixarea1 	= $6f800

xypos	 = $50000
xyz_zoom = $51000
antal = 380		;faktiske antal prikker := ANTAL * 2
zooms = 28



BLTW:	 MACRO
	btst	#14,$2(a6)
	bne.B	*-6
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	 IFEQ DEMOSTARTUP
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.w	#$01b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	move.w	#$203,$180(a6)
	move.w	#$0200,$100(a6)

	lea	matrixarea1,a1
	moveq	#-128,d1
	moveq	#15,d2
	move.w	#255,d7
.mloop1	lea	sintabel,a0
	move.w	#255,d6
.mloop2	move.w	(a0),d0
	muls	d1,d0
	add.l	d0,d0
	swap	d0
	move.b	d0,(a1)+
	addq.l	#4,a0
	dbf	d6,.mloop2
	addq.w	#1,d1
	dbf	d7,.mloop1
	lea	matrixarea1,a0
	move.w	#255,d1
.mloop3	move.b	(a0)+,(a1)+
	dbf	d1,.mloop3

	lea	screen1,a0
	move.l	#size*3,d0
	bsr.W	fill

	lea	ytabel(pc),a0
	moveq	#0,d0
	move.w	#255,d1
.ytab1	move.w	d0,(a0)+
	addi.w	#width*2,d0
	dbf	d1,.ytab1
	subi.w	#40*width*2,d0
	move.w	#255,d1
.ytab2	move.w	d0,(a0)+
	subi.w	#width*2,d0
	dbf	d1,.ytab2

.rc1	cmp.b	#$a0,$6(a6)
	bne.S	.rc1
	bsr.W	calc_xypos

.rc2	cmp.b	#$ff,$6(a6)
	bne.S	.rc2
	lea	CP(pc),a0
	move.l	a0,$80(a6)
	move.w	#$83d0,DMACON(a6)

	clr.w	count

*-----------------------*
*	MAIN LOOP	*

ML:
;	move.w	#$f00,$180(a6)
	move.l	$4(a6),d0
	lsr.l	#1,d0
	lsr.w	#7,d0
	cmpi.w	#$128,d0
	bne.S	ML
;	clr.w	$180(a6)

	bsr.W	T1

	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001
	beq.S	.exit
	 ENDC

	lea	count(pc),a0
	addq.w	#1,(a0)
	cmpi.w	#$42f,(a0)
	bne.S	ML

.exit	BLTW
	moveq	#0,d0
	rts


*-----------------
* TASK 1 - sphere

T1:	lea	display(pc),a0
	movem.l	(a0),d0-d2
	movem.l	d1/d2,(a0)
	move.l	d0,8(a0)

	move.l	d0,a1
	lea	CPptr(pc),a0
	moveq	#width,d0
	moveq	#2,d7
	bsr.W	copins

	BLTW
	move.l	#$01000000,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	move.l	display+4(pc),a0
	move.l	a0,BLTDPT(a6)
	clr.w	BLTDMOD(a6)
	move.w	#[216*2]<<6+14,BLTSIZE(a6)

	lea	vinkel(pc),a0
	movem.w	angleadd(pc),d0/d1
	add.w	d0,(a0)
	add.w	d1,2(a0)
	movem.w	(a0),d0/d1
	lsr.w	#1,d0
	lsr.w	#1,d1
	lea	.mat1(pc),a0
	move.b	d0,3(a0)
	move.b	d0,7(a0)
	move.b	d0,11(a0)
	move.b	d0,15(a0)
	lea	.mat2(pc),a0
	move.b	d1,3(a0)
	move.b	d1,7(a0)
	move.b	d1,11(a0)
	move.b	d1,15(a0)

	lea	xypos,a0
	lea	zoompos(pc),a1
	tst.w	(a1)
	bmi.B	.nozoom
	move.w	(a1),d7
	not.w	2(a1)
	bne.B	.nozoomadd
	subq.w	#1,(a1)

	move.w	#256,d6
	cmp.w	#32,count
	bhi.B	.fadeok
	move.w	count(pc),d6
	lsl.w	#3,d6
.fadeok	lea	CPcolors(pc),a0
	move.w	#$afa,d1
	move.w	#$203,d0
	bsr.W	fade
	move.w	d0,2(a0)
	move.w	d0,10(a0)
	move.w	#$272,d1
	move.w	#$203,d0
	bsr.W	fade
	move.w	d0,6(a0)
.nozoomadd

	lea	xyz_zoom,a0
	mulu	#antal*8,d7
	adda.l	d7,a0
.nozoom

	lea	matrixarea1+$8080,a1
	lea	64(a1),a2
	lea	ytabel+256-40(pc),a3
	lea	512(a3),a4
	move.l	display(pc),a5
	adda.w	#14,a5
	moveq	#8,d4
	moveq	#3,d5
	move.w	#antal-1,d7

.loop	movem.w	(a0)+,d0-d3		;d2 = d3
.mat1	move.b	$00(a1,d1.W),d2
	move.b	$00(a2,d1.W),d1
	sub.b	$00(a1,d3.W),d1
	add.b	$00(a2,d3.W),d2
	lsl.w	d4,d2
.mat2	move.b	$00(a2,d0.W),d3
	add.b	$00(a1,d2.W),d3
	move.b	$00(a2,d2.W),d2
	sub.b	$00(a1,d0.W),d2
	bpl.B	.color
	ext.w	d3
	ext.w	d1
	move.w	d3,d6
	add.w	d1,d1
	move.w	d1,d2

	move.w	d3,d0
	asr.w	d5,d3
	add.w	(a3,d1.W),d3
	not.b	d0
	bset	d0,(a5,d3.W)
	neg.w	d6
	move.w	d6,d0
	asr.w	d5,d6
	add.w	(a4,d2.W),d6
	not.b	d0
	bset	d0,width(a5,d6.W)
	dbf	d7,.loop
	rts
.color	ext.w	d3
	ext.w	d1
	move.w	d3,d6
	add.w	d1,d1
	move.w	d1,d2

	move.w	d3,d0
	asr.w	d5,d3
	add.w	(a3,d1.W),d3
	not.b	d0
	bset	d0,width(a5,d3.W)
	neg.w	d6
	move.w	d6,d0
	asr.w	d5,d6
	add.w	(a4,d2.W),d6
	not.b	d0
	bset	d0,(a5,d6.W)
	dbf	d7,.loop
	rts

* TASK 1 data
number:		dc.w 0
display:	dc.l screen1,screen2,screen3
vinkel:		dc.w 0,64
ytabel:		ds.w 256
		ds.w 256
angleadd:	dc.w 2,2
zoompos:	dc.w zooms-1,-1

*-------------*
* CALC KOORDS *

calc_xypos:
	lea	sintabel,a1
	lea	256(a1),a2
	lea	.calc1+2(pc),a4
	lea	xypos,a5
	moveq	#0,d3
	move.w	#$3fe,d4
	move.w	#antal-1,d7
.matrix_calc
	add.w	$6(a6),d0
	mulu	d3,d0
	add.w	#$1249,d0
	eor.w	d0,d3
	add.w	d0,d1
	muls	d3,d1
	eor.w	#$1249,d1
	add.w	d1,d3
	add.w	(a4),d3
	eor.w	d7,d3

	and.w	d4,d0
	and.w	d4,d1
	move.w	(a1,d0.W),(a4)
	move.w	(a2,d0.W),4(a4)
	move.w	(a1,d1.W),[.calc2-.calc1](a4)
	move.w	(a2,d1.W),[.calc2-.calc1]+4(a4)
	moveq	#0,d0
	moveq	#0,d1
	move.w	#105,d2
	move.w	d2,d1
.calc2	muls	#$0000,d1
	muls	#$0000,d2
	add.l	d1,d1
	swap	d1
	neg.w	d1
	add.l	d2,d2
	swap	d2
	move.w	d2,d0
.calc1	muls	#$0000,d0
	muls	#$0000,d2
	add.l	d0,d0
	swap	d0
	neg.w	d0
	add.l	d2,d2
	swap	d2
	lsl.w	#8,d0
	lsl.w	#8,d1
	lsl.w	#8,d2
	move.w	d0,(a5)+
	move.w	d1,(a5)+
	move.w	d2,(a5)+
	move.w	d2,(a5)+
	dbf	d7,.matrix_calc

	lea	xyz_zoom,a1
	move.w	#256,d5
	moveq	#zooms-1,d7
.loop1	lea	xypos,a0
	move.w	#antal-1,d6
.loop2	movem.w	(a0)+,d0/d1/d2/d3		;d3 bruges ikke
	ext.l	d0
	ext.l	d1
	ext.l	d2
	divs	d5,d0
	divs	d5,d1
	divs	d5,d2
	move.b	d0,(a1)+
	clr.b	(a1)+
	move.b	d1,(a1)+
	clr.b	(a1)+
	move.b	d2,(a1)+
	clr.b	(a1)+
	move.b	d2,(a1)+
	clr.b	(a1)+
	dbf	d6,.loop2
	addi.w	#24,d5
	dbf	d7,.loop1
	rts

* CALC XY DATA
rand:		dc.w 1000
count:		dc.w 0
rnd:		dc.l 0


*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800203
 dc.l $008e3cb1,$00901591,$00920050,$009400b8
 dc.l $01000200,$01020000,$01040024
 dc.w $0108,width,$010a,width
 dc.l $01200000,$01220000,$01400000,$01420000
CPptr:
 dc.w $00e0,screen1/$10000,$00e2,screen1&$ffff
 dc.w $00e4,screen1/$10000,$00e6,screen1&$ffff
CPcolors:
 dc.l $01820AFA,$01840272,$01860AFA
 dc.l $01002200
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*

fill:	clr.l	(a0)+
	clr.l	(a0)+
	subq.l	#8,d0
	bpl.B	fill
	rts

copins:	move.l	a1,d1
	swap	d1
	move.w	d1,2(a0)
	move.w	a1,6(a0)
	adda.w	d0,a1
	addq.l	#8,a0
	subq.w	#1,d7
	bne.S	copins
	rts

fade:	move.w	d1,d3
	move.w	d0,d1
	move.w	d0,d2
	move.w	d3,d4
	move.w	d3,d5
	andi.w	#$00f,d0
	andi.w	#$0f0,d1
	andi.w	#$f00,d2
	andi.w	#$00f,d3
	andi.w	#$0f0,d4
	andi.w	#$f00,d5
	sub.w	d0,d3
	sub.w	d1,d4
	sub.w	d2,d5
	muls	d6,d3
	muls	d6,d4
	muls	d6,d5
	asr.l	#8,d3
	asr.l	#8,d4
	asr.l	#8,d5
	andi.w	#$00f,d3
	andi.w	#$0f0,d4
	andi.w	#$f00,d5
	add.w	d3,d0
	add.w	d4,d1
	add.w	d5,d2
	or.w	d2,d0
	or.w	d1,d0
	rts
 END

