; dot world
;								TAS / jul1992

DEMOSTARTUP = 0


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000

 INCLUDE chipmap.inc
 ORG $30000
 LOAD $30000
sintabel = $27800
>EXTERN "df0:sin1024.data",sintabel


width = 40
ytabel = $7f000
buffer = $7f300

kodeloop = $5d800

world	 = $5f000
xsize SET 16
ysize SET 16

ybuffer = $6f000
screen1 = $70000
screen2 = $75000
screen3 = $7a000


BLTW:	 MACRO
	btst	#14,$2(a6)
	bne.B	*-6
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	clr.l	$0.W
	 IFEQ DEMOSTARTUP
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.w	#$01b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	move.w	#$203,$180(a6)
	clr.w	$36(a6)


*-------
* SETUP

	lea	ytabel,a0 
	moveq	#0,d0
	move.w	#255,d7
.ytabel	move.w	d0,(a0)+
	addi.w	#width,d0
	dbf	d7,.ytabel

	bsr.W	opstil_dottabel
	bsr.W	opstil_sintabel

	lea	screen1,a0
	move.l	#$5000,d0
	bsr.W	clear

	lea	CP(pc),a0
	move.l	a0,$80(a6)
	move.w	#$83f0,DMACON(a6)

*---------------------*
*      MAIN LOOP      *

ML:	move.w	#$120,d0
	bsr.W	RC

	bsr.B	dots
	bra.B	ML

	BLTW
	rts


*--------------------
* TASK 1 - dot world

dots:	lea	display(pc),a0
	movem.l	(a0),d0-d2
	movem.l	d1/d2,(a0)
	move.l	d0,8(a0)

	move.l	d0,a0
	lea	CPptr(pc),a1
	move.w	#width*256,d0
	moveq	#2,d1
	bsr.W	copins

	BLTW
	move.l	#$01000000,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	move.l	display+4(pc),a0
	move.l	a0,BLTDPT(a6)
	move.w	#0,BLTDMOD(a6)
	move.w	#256<<7+20,BLTSIZE(a6)

	bsr.W	mousecontrol
	bsr.W	DisplayView

	move.l	display(pc),a0
	lea	256*40(a0),a1
	lea	ydata,a2
	lea	ybuffer,a3
	moveq	#0,d0
	moveq	#0,d1
	move.w	#128,d2
	jsr	kodeloop
	rts
	
* TASK 1 data
display:	dc.l screen1,screen2,screen3
xadd:		dc.w 0,0
yadd:		dc.w 0,0
ydata:		blk.b 256,0
vinkel:		dc.w 0
posbuffer:	ds.w 4*2
mousexy:	dc.w 0

mousecontrol:
	lea	vinkel(pc),a4
	lea	mousexy(pc),a0
	move.w	JOY0DAT(a6),d1

	move.b	1(a0),d0
	move.b	d1,1(a0)
	sub.b	d1,d0
	ext.w	d0
	add.w	d0,(a4)
	andi.w	#$3FE,(a4)
	rts


DisplayView:
	lea	sintabel,a1
	lea	256(a1),a2
	move.w	vinkel(pc),d0
	andi.w	#$3fe,d0
	move.w	(a1,d0.W),sincos+2
	move.w	(a1,d0.W),sincos+6
	move.w	(a2,d0.W),sincos+10
	move.w	(a2,d0.W),sincos+14

	btst	#6,$bfe001
	bne.B	.nospeed
	moveq	#0,d0
	moveq	#127,d1
	bsr.W	zrotate
	lea	xadd(pc),a0
	add.w	d0,2(a0)
	move.w	2(a0),d0
	asr.w	#8,d0
	andi.w	#$ff,d0
	move.w	d0,(a0)
	lea	yadd(pc),a0
	add.w	d1,2(a0)
	move.w	2(a0),d0
	asr.w	#8,d0
	andi.w	#$ff,d0
	move.w	d0,(a0)
.nospeed
	bsr.W	calc_udsyn

	lea	posbuffer,a0
	lea	world,a1
	lea	ydata(pc),a4
	movem.w	(a0),d5/d6			;calc X
	movem.w	4(a0),d3/d4
	sub.w	d3,d5
	sub.w	d4,d6
	ext.l	d5
	ext.l	d6
	moveq	#12,d0
	asl.l	d0,d5
	asl.l	d0,d6
	move.l	d5,a2
	move.l	d6,a3

	movem.w	4(a0),d5/d6			;calc Y
	movem.w	12(a0),d3/d4
	sub.w	d3,d5
	sub.w	d4,d6
	ext.l	d5
	ext.l	d6
	moveq	#12,d0
	asl.l	d0,d5
	asl.l	d0,d6
	swap	d3
	swap	d4
	clr.w	d3
	clr.w	d4
	move.w	xadd(pc),a5
	move.w	yadd(pc),a6
	moveq	#ysize-1,d7
.loop1	movem.l	d3/d4/d7,-(sp)
	moveq	#0,d7		;\ D7 =
	subq.b	#1,d7		;/ $000000FF
	moveq	#xsize-1,d2
.loop2	move.l	d3,d0
	move.l	d4,d1
	swap	d0
	swap	d1
	add.w	a5,d0		;add xpos
	add.w	a6,d1		;  & ypos
	and.l	d7,d0
	and.w	d7,d1
	lsl.w	#8,d1
	add.w	d1,d0
	move.b	(a1,d0.L),(a4)+
	add.l	a2,d3
	add.l	a3,d4
	dbf	d2,.loop2
	movem.l	(sp)+,d3/d4/d7
	add.l	d5,d3
	add.l	d6,d4
	dbf	d7,.loop1
	lea	DMA,a6
	rts

calc_udsyn:
	lea	posbuffer(pc),a0
	moveq	#-xsize/2,d0	;00
	moveq	#0,d1		;x0
	bsr.W	zrotate
	move.w	d0,(a0)+
	move.w	d1,(a0)+
	moveq	#xsize/2,d0	;00
	moveq	#0,d1		;0x
	bsr.W	zrotate
	move.w	d0,(a0)+
	move.w	d1,(a0)+
	moveq	#-xsize/2,d0	;x0
	moveq	#ysize,d1	;00
	bsr.W	zrotate
	move.w	d0,(a0)+
	move.w	d1,(a0)+
	moveq	#xsize/2,d0	;0x
	moveq	#ysize,d1	;00
	bsr.W	zrotate
	move.w	d0,(a0)+
	move.w	d1,(a0)+
	rts

zrotate:
	move.w	d0,d3
	move.w	d1,d4
sincos	muls	#0,d3
	muls	#0,d4
	muls	#0,d0
	muls	#0,d1
	sub.l	d4,d0
	add.l	d3,d1
	add.l	d0,d0
	swap	d0
	add.l	d1,d1
	swap	d1
	rts




*------------------*
* Opstil sin tabel *
opstil_sintabel:
	lea	world,a0
	lea	sin256(pc),a1
	moveq	#3,d0
	moveq	#64,d1
	moveq	#20,d4
	moveq	#14,d5
	move.w	#0,a2

	move.w	#255,d7
slop1	movem.w	d0/d1/d7,-(sp)
	move.w	#$1ff,d7
	move.w	#255,d6
	moveq	#0,d3
slop2
	and.w	d7,d0
	and.w	d7,d1
	moveq	#0,d2
	move.b	(a1,d0.W),d2
	move.b	(a1,d1.W),d3
	add.w	d3,d2
	move.b	(a1,d2.W),d3
	lsr.w	#1,d3
	add.w	d3,d2

	lsr.w	#2,d2
	add.w	d2,d2
	move.b	d2,(a0)+
	sub.w	d4,d0
	add.w	d5,d1
	dbf	d6,slop2
	movem.w	(sp)+,d0/d1/d7
add1:	addi.w	#20,d0
	subi.w	#14,d1
	and.w	d7,d0
	and.w	d7,d1
	bsr.W	new_func
	dbf	d7,slop1
	rts

new_func:
	move.w	add1+2(pc),d2
	tst.w	retning
	bne.B	.otherway
	subq.w	#1,d2
	cmpi.w	#-10,d2
	bge.B	.wild1
	not.w	retning
	bra.B	.wild1
.otherway
	addq.w	#1,d2
	cmpi.w	#10,d2
	ble.B	.wild1
	not.w	retning
.wild1	move.w	d2,add1+2
	move.w	d2,d3
	rts
	and.w	#3,d2
	bne.W	.wild2
	subq.w	#1,add1+6
.wild2	and.w	#7,d3
	bne.W	.wild3
	subq.w	#2,d5
.wild3	rts

retning:	dc.w 0

*
* SINUSDATA "df0:SIN256.512"
*
sin256:	DC.B	$00,$01,$03,$04,$06,$07,$09,$0A
	DC.B	$0C,$0E,$0F,$11,$12,$14,$15,$17
	DC.B	$18,$1A,$1C,$1D,$1F,$20,$22,$23
	DC.B	$25,$26,$28,$29,$2B,$2C,$2E,$2F
	DC.B	$30,$32,$33,$35,$36,$38,$39,$3A
	DC.B	$3C,$3D,$3F,$40,$41,$43,$44,$45
	DC.B	$47,$48,$49,$4A,$4C,$4D,$4E,$4F
	DC.B	$51,$52,$53,$54,$55,$57,$58,$59
	DC.B	$5A,$5B,$5C,$5D,$5E,$5F,$60,$61
	DC.B	$62,$63,$64,$65,$66,$67,$68,$69
	DC.B	$6A,$6B,$6C,$6C,$6D,$6E,$6F,$70
	DC.B	$70,$71,$72,$73,$73,$74,$75,$75
	DC.B	$76,$76,$77,$77,$78,$79,$79,$7A
	DC.B	$7A,$7A,$7B,$7B,$7C,$7C,$7C,$7D
	DC.B	$7D,$7D,$7E,$7E,$7E,$7E,$7F,$7F
	DC.B	$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
	DC.B	$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
	DC.B	$7F,$7F,$7F,$7E,$7E,$7E,$7E,$7D
	DC.B	$7D,$7D,$7C,$7C,$7C,$7B,$7B,$7A
	DC.B	$7A,$7A,$79,$79,$78,$77,$77,$76
	DC.B	$76,$75,$75,$74,$73,$73,$72,$71
	DC.B	$70,$70,$6F,$6E,$6D,$6C,$6C,$6B
	DC.B	$6A,$69,$68,$67,$66,$65,$64,$63
	DC.B	$62,$61,$60,$5F,$5E,$5D,$5C,$5B
	DC.B	$5A,$59,$58,$57,$55,$54,$53,$52
	DC.B	$51,$4F,$4E,$4D,$4C,$4A,$49,$48
	DC.B	$47,$45,$44,$43,$41,$40,$3F,$3D
	DC.B	$3C,$3A,$39,$38,$36,$35,$33,$32
	DC.B	$30,$2F,$2E,$2C,$2B,$29,$28,$26
	DC.B	$25,$23,$22,$20,$1F,$1D,$1C,$1A
	DC.B	$18,$17,$15,$14,$12,$11,$0F,$0E
	DC.B	$0C,$0A,$09,$07,$06,$04,$03,$01
	blk.b 256,0

*------------------*
* Opstil dot tabel *

ypos SET 80
opstil_dottabel:
	lea	sintabel,a1
	lea	256(a1),a2
	move.w	#$62,d0
	andi.w	#$3fe,d0
	move.w	(a1,d0.W),calc4+2
	move.w	(a1,d0.W),calc4+6
	move.w	(a2,d0.W),calc4+10
	move.w	(a2,d0.W),calc4+14

	lea	kodeloop,a4
	lea	ybuffer,a5
	move.w	#260+[10*8],d6		;Z start
	moveq	#ysize-1,d7
.loop1
	movem.w	d6-d7,-(sp)

	lea	buffer,a0
	movea.w	#160,a1
	movea.w	#100,a2
	moveq	#15,d5
	moveq	#xsize-1,d7
	moveq	#-10*8,d0
.loop2
	move.l	d0,a3
	moveq	#ypos-48,d1
	moveq	#$0,d2
	bsr.W	rotatey
	addi.w	a1,d0
	addi.w	a2,d1
	move.w	d0,(a0)+
	move.w	d1,(a0)+
	moveq	#ypos,d1
	moveq	#$0,d2
	bsr.W	rotatey
	addi.w	a1,d0
	addi.w	a2,d1
	move.w	d0,(a0)+
	move.w	d1,(a0)+
	move.l	a3,d0
	addi.l	#10,d0
	dbf	d7,.loop2

	lea	kodestykke_3(pc),a3
	move.w	2(sp),d0
	cmpi.w	#10,d0
	bhi.B	.col3
	lea	kodestykke_2(pc),a3
	cmpi.w	#5,d0
	bhi.B	.col3
	lea	kodestykke_1(pc),a3
.col3

	lea	buffer,a1
	moveq	#xsize-1,d7
.loop3
	move.l	a3,a2
	move.w	(a2)+,(a4)+	;MOVE.B (a2)+,d1
	cmp.w	#320,(a1)	;uden for skrmen
	bhs.B	.nodot

	move.w	(a2)+,(a4)+	;kopier
	move.l	(a2)+,(a4)+	;resten
	move.l	(a2)+,(a4)+	;af loop-stykke
	move.l	(a2)+,(a4)+
	move.w	(a2)+,(a4)+
	move.w	(a1),d0
	move.w	d0,d1
	asr.w	#3,d0
	not.b	d1
	andi.w	#7,d1
	move.b	d1,-9(a4)	;indst
	move.b	d0,-7(a4)	;faste
	move.b	d1,-3(a4)	;bit pos
	move.b	d0,-1(a4)	;i megakode
.nodot
	addq.l	#8,a1
	dbf	d7,.loop3
	move.w	#$d6c2,(a4)+	;ADDA.W D2,A3

	lea	buffer,a0		;calc y-coords for a single 'mountain'
	lea	ytabel,a2
	move.w	2(a0),d5
	move.w	6(a0),d3
	sub.w	d3,d5
	ext.l	d5
	moveq	#10,d0
	asl.l	d0,d5
	swap	d3
	clr.w	d3
	moveq	#63,d2			;64 y-positions
.yloop	move.l	d3,d0
	swap	d0
	add.w	d0,d0
	move.w	(a2,d0.W),d0
	move.w	d0,(a5)+
	add.l	d5,d3
	dbf	d2,.yloop

	movem.w	(sp)+,d6-d7
	subi.w	#18,d6			;Z add
	dbf	d7,.loop1
	move.w	#$4e75,(a4)+		;RTS
	rts

rotateY:
	move.w	d2,d4
	move.w	d1,d3
calc4	muls	#0,d3
	muls	#0,d4
	muls	#0,d1
	muls	#0,d2
	sub.l	d4,d1
	add.l	d3,d2
	asr.l	d5,d1
	asr.l	d5,d2
	add.w	d6,d2
	asl.l	#8,d0
	asl.l	#8,d1
	divs	d2,d0
	divs	d2,d1
	rts

kodestykke_1 = *
	move.b	(a2)+,d1
	move.w	(a3,d1.W),d0
	bset	#0,0(a0,d0.W)
	bclr	#0,0(a1,d0.W)
kodestykke_2 = *
	move.b	(a2)+,d1
	move.w	(a3,d1.W),d0
	bclr	#0,0(a0,d0.W)
	bset	#0,0(a1,d0.W)
kodestykke_3 = *
	move.b	(a2)+,d1
	move.w	(a3,d1.W),d0
	bset	#0,0(a0,d0.W)
	bset	#0,0(a1,d0.W)

*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800203
 dc.l $008e2881,$009027c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.w $0108,0,$010a,0
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000

 dc.l $2801fffe
 dc.l $01002200
CPptr:
 dc.w $00e0,screen1/$10000
 dc.w $00e2,screen1&$ffff
 dc.w $00e4,screen1/$10000
 dc.w $00e6,screen1&$ffff+[40*256]
 dc.l $01820afa,$018405a5,$01860272
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

copins:	move.l	a0,d2
	swap	d2
	move.w	d2,2(a1)
	move.w	a0,6(a1)
	adda.w	d0,a0
	addq.l	#8,a1
	subq.w	#1,d1
	bne.B	copins
	rts

 END

