; picture xyz-rotation
;								TAS / nov1992


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000
*  vectorscreens		$40000	$49000
*  tabels			$5e000	$60000

 include chipmap.inc
 org $28000
 load $28000
>extern "df0:sin1024.data",sintabel
>extern "df0:rotate64*64.bpl",picture

width = 40
picture = $2a000

size = 195*width*4
screen1	= $50000
screen2	= screen1+size

sintabel	= $27800

xy1buffer	= $60000
xy2buffer	= $60400
punishertabel	= $64800
ytabel		= $7f400
vectorbuffer	= $7f800


BLTW:	 MACRO
.\@	btst	#14,$2(a6)
	bne.B	.\@
	 ENDM

*------------------*
* START UP PROGRAM *

s	lea	DMA,a6
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	move.w	#$01bf,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	clr.w	$180(a6)

*-------
* SETUP

	clr.w	$36(a6)

	lea	screen1,a0
	move.l	#size*2,d0
	bsr.W	fill

	bsr.W	maketabel

	lea	ytabel,a0
	moveq	#0,d0
	move.w	#255,d7
.ytab	move.w	d0,(a0)+
	addi.w	#width*4,d0
	dbf	d7,.ytab

	move.l	#CP,$80(a6)
	move.w	#$83f0,DMACON(a6)

*-----------------------*
*	MAIN LOOP	*

ML:	move.b	#$ff,d0
	bsr.W	RC
	bsr.B	filledvector
	bsr.W	dotcalc

	btst	#6,$bfe001
	bne.B	ML

	BLTW
	rts


*-----------------------
* filled vector routine

filledvector:
	lea	display(pc),a2
	movem.l	(a2),d0-d3
	movem.l	d2/d3,(a2)
	movem.l	d0/d1,8(a2)
	lea	copptrs(pc),a1
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	swap	d0
	addi.l	#width,d0
	move.w	d0,14(a1)
	swap	d0
	move.w	d0,10(a1)
	swap	d0
	addi.l	#width,d0
	move.w	d0,22(a1)
	swap	d0
	move.w	d0,18(a1)
	swap	d0
	addi.l	#width,d0
	move.w	d0,30(a1)
	swap	d0
	move.w	d0,26(a1)

	move.l	4(a2),a0
	tst.l	(a0)
	beq.B	.noclrmem
	BLTW
	move.l	#$01000002,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.l	(a0)+,BLTDPT(a6)
	move.w	(a0)+,BLTDMOD(a6)
	move.w	(a0)+,BLTSIZE(a6)
.noclrmem
	bsr.W	matrixcalc

	move.l	strukturptr(pc),a5
	move.l	4(a5),a0
	lea	vectorbuffer,a1
	lea	matrix_vectors(pc),a2
	movea.w	#800,a3
	moveq	#6,d4
.vecloop1
	movem.w	(a0)+,d5-d7
	move.w	d5,d0
	move.w	d6,d1
	move.w	d7,d2
	muls	(a2)+,d0
	muls	(a2)+,d1
	muls	(a2)+,d2
	add.l	d1,d0
	add.l	d2,d0
	asr.l	d4,d0

	move.w	d5,d1
	move.w	d6,d2
	move.w	d7,d3
	muls	(a2)+,d1
	muls	(a2)+,d2
	muls	(a2)+,d3
	add.l	d2,d1
	add.l	d3,d1
	asr.l	d4,d1

	muls	(a2)+,d5
	muls	(a2)+,d6
	muls	(a2)+,d7
	add.l	d6,d5
	add.l	d7,d5
	lsr.l	d4,d5
	lsr.l	#8,d5
	add.w	a3,d5
	divs	d5,d0
	divs	d5,d1
	addi.w	#160,d0
	addi.w	#95,d1
	move.w	d0,(a1)+
	move.w	d1,(a1)+
	lea	-18(a2),a2
	cmp.w	#$8000,(a0)
	bne.W	.vecloop1

	bsr.W	polykill

	move.l	(a5),a0
	movem.l	vecregs(pc),a1-a4
	move.l	#$01400000,(a3)
	move.l	#$00c30000,4(a3)
	BLTW
	move.w	#$ffff,$44(a6)
	move.l	#$ffff8000,$72(a6)
	move.w	#width*4,$60(a6)
	move.w	#width*4,$66(a6)
.vecloop2
	moveq	#0,d7
	tst.b	(a0)+
	beq.B	.vecloop2a
	bmi.B	.vecdrawend
	move.b	(a0)+,d7
	lea	2(a0,d7.W),a0
	bra.B	.vecloop2
.vecloop2a
	move.b	(a0)+,d7
	subq.w	#1,d7
	move.b	(a0)+,color
.vecloop2b
	moveq	#0,d5
	moveq	#0,d6
	move.b	(a0)+,d5
	bmi.B	.vecloop2b
	move.b	(a0),d6
	bmi.B	.vecloop2b
	lsl.w	#2,d5
	lsl.w	#2,d6
	movem.w	(a1,d5.W),d0/d1
	movem.w	(a1,d6.W),d2/d3
	bsr.W	drawvector
	dbf	d7,.vecloop2b
	addq.l	#1,a0
	bra.B	.vecloop2
.vecdrawend

	movem.w	(a3),d0-d3
	subq.w	#2,d0
	addq.w	#2,d1
	subq.w	#2,d2
	addq.w	#2,d3
	tst.w	d0
	bpl.B	.vecb1
	clr.w	d0
.vecb1	cmpi.w	#319,d1
	ble.B	.vecb2
	move.w	#319,d1
.vecb2	tst.w	d2
	bge.B	.vecb3
	clr.w	d2
.vecb3	cmpi.w	#195,d3
	ble.B	.vecb4
	move.w	#195,d3
.vecb4
	move.w	d3,d4
	add.w	d4,d4
	move.w	(a4,d4.W),d4
	sub.w	d2,d3
	addq.w	#1,d3
	ble.B	.nofill
	lsl.w	#2,d3
	lsl.w	#6,d3

	lsr.w	#3,d0
	lsr.w	#3,d1
	add.w	d1,d4
	sub.w	d0,d1
	addq.w	#3,d1
	ble.B	.nofill
	lsr.w	#1,d1
	add.w	d1,d3
	add.w	d1,d1
	moveq	#width,d0
	sub.w	d1,d0
	move.w	d0,d1
	swap	d0
	move.w	d1,d0
	move.l	display(pc),a0
	adda.w	d4,a0
	move.l	a0,a1
	BLTW
	move.l	#$09f00012,BLTCON0(a6)
	move.l	#-1,BLTAFWM(a6)
	movem.l	a0/a1,BLTAPT(a6)
	move.l	d0,BLTAMOD(a6)
	move.w	d3,BLTSIZE(a6)
	move.l	display+4(pc),a2
	move.l	a0,(a2)
	movem.w	d0/d3,4(a2)
.nofill
	rts


drawvector:
	cmp.w	d1,d3
	bgt.B	.vecdrw1
	exg	d0,d2
	exg	d1,d3
	beq.W	noline
.vecdrw1
	cmp.w	(a3),d0
	bgt.B	.vecb1
	move.w	d0,(a3)
.vecb1	cmp.w	(a3),d2
	bgt.B	.vecb2
	move.w	d2,(a3)
.vecb2	cmp.w	2(a3),d0
	blt.B	.vecb3
	move.w	d0,2(a3)
.vecb3	cmp.w	2(a3),d2
	blt.B	.vecb4
	move.w	d2,2(a3)
.vecb4	cmp.w	4(a3),d1
	bgt.B	.vecb5
	move.w	d1,4(a3)
.vecb5	cmp.w	6(a3),d3
	blt.B	.vecb6
	move.w	d3,6(a3)
.vecb6
	move.w	d1,d4
	sub.w	d3,d4
	cmp.w	d0,d2
	beq.B	.vecdraw4
	blo.B	.vecdraw2
	move.w	d0,d5
	sub.w	d2,d5
	bra.B	.vecdraw3
.vectorcontrol dc.b $01,$11,$09,$15,$05,$19,$0d,$1d
.vecdraw2
	move.w	d2,d5
	sub.w	d0,d5
.vecdraw3
	add.w	d4,d4
	cmp.w	d4,d5
	bhi.B	.vecdraw4
	subq.w	#1,d3
.vecdraw4
	moveq	#0,d4
	move.w	d1,d4
	add.w	d4,d4
	move.w	(a4,d4.W),d4
	moveq   #-16,d5
	and.w	d0,d5
	lsr.w	#3,d5
	add.w	d5,d4
	add.l	display(pc),d4
	moveq	#0,d5
	sub.w	d1,d3
	bge.B	.vecdraw5
	neg.w	d3
.vecdraw5
	sub.w	d0,d2
	roxl.b	#1,d5
	tst.w	d2
	bge.B	.vecdraw6
	neg.w	d2
.vecdraw6
	move.w	d3,d1
	sub.w	d2,d1
	bge.B	.vecdraw7
	exg	d2,d3
.vecdraw7
	roxl.b	#1,d5
	move.b	.vectorcontrol(pc,d5.W),d5
	andi.w	#$f,d0
	ror.w	#4,d0
	ori.w	#$0b4a,d0
	add.w	d2,d2
	move.w	d2,d1
	sub.w	d3,d2
	bge.B	.vecdraw8
	ori.b	#$40,d5
.vecdraw8
	ori.b	#3,d5
	move.w	d2,d6
	sub.w	d3,d2
	lsl.w	#6,d3
	addq.w	#2,d3
	btst	#0,color
	beq.B	.col1
	BLTW
	movem.w	d0/d5,$40(a6)
	movem.w	d1/d2,$62(a6)
	move.w	d6,$52(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d3,$58(a6)
.col1	addi.l	#width,d4
	btst	#1,color
	beq.B	.col2
	move.w	#$8400,$96(a6)
	BLTW
	move.w	#$0400,$96(a6)
	movem.w	d0/d5,$40(a6)
	movem.w	d1/d2,$62(a6)
	move.w	d6,$52(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d3,$58(a6)
.col2	addi.l	#width,d4
	btst	#2,color
	beq.B	.col3
	move.w	#$8400,$96(a6)
	BLTW
	move.w	#$0400,$96(a6)
	movem.w	d0/d5,$40(a6)
	movem.w	d1/d2,$62(a6)
	move.w	d6,$52(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d3,$58(a6)
.col3	addi.l	#width,d4
	btst	#3,color
	beq.B	noline
	move.w	#$8400,$96(a6)
	BLTW
	move.w	#$0400,$96(a6)
	movem.w	d0/d5,$40(a6)
	movem.w	d1/d2,$62(a6)
	move.w	d6,$52(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d3,$58(a6)
noline	rts


polykill:
	move.l	(a5),a1
	lea	vectorbuffer,a0
.loop	clr.b	(a1)
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	move.b	3(a1),d0
	move.b	4(a1),d1
	move.b	5(a1),d2
	lsl.w	#2,d0
	lsl.w	#2,d1
	lsl.w	#2,d2
	movem.w	(a0,d1.W),d3/d4
	movem.w	(a0,d2.W),d5/d6
	movem.w	(a0,d0.W),d0/d1
	sub.w	d3,d0
	sub.w	d4,d1
	sub.w	d3,d5
	sub.w	d4,d6
	muls	d1,d5
	muls	d0,d6
	sub.l	d6,d5
	bpl.B	.vecsortA
	move.b	#1,(a1)
.vecsortA
	moveq	#0,d0
	move.b	1(a1),d0
	lea	4(a1,d0.W),a1
	tst.b	(a1)
	bpl.B	.loop
	rts

* DATA *
display		dc.l screen1,edges+8,screen2,edges+16
vecregs		dc.l vectorbuffer,0,edges,ytabel
color		dc.b 0
 even
vectorxy	dc.w 0,0,0
edges		dc.w 320,0,195,0
		dc.l 0,0, 0,0, 0,0

*-------------
* matrix calc

matrixcalc:
	lea	vectorxy(pc),a4
	move.l	strukturptr(pc),a5

	lea	mousexy(pc),a0
	move.w	JOY0DAT(a6),d1

	btst	#10,$16(a6)			;right mousebutton?
	bne.B	.noright
	move.b	(a0),d0
	move.b	d1,(a0)+
	sub.b	d1,d0
	ext.w	d0
	add.w	d0,2(a4)
	lsr.w	#8,d1
	move.b	(a0),d0
	move.b	d1,(a0)
	sub.b	d1,d0
	ext.w	d0
	add.w	d0,(a4)
	bra.B	.sincos
.noright
	move.b	d1,(a0)
	lsr.w	#8,d1
	move.b	d1,1(a0)
	movem.w	20(a5),d0-d2
	add.w	d0,(a4)
	add.w	d1,2(a4)
	add.w	d2,4(a4)

.sincos	lea	sintabel,a1
	lea	256(a1),a2
	movem.w	(a4),d0-d2
	move.w	#$3fe,d3
	and.w	d3,d0
	and.w	d3,d1
	and.w	d3,d2
	move.w	(a1,d0.W),calc4+2
	move.w	(a1,d0.W),calc4+6
	move.w	(a2,d0.W),calc4+10
	move.w	(a2,d0.W),calc4+14
	move.w	(a1,d1.W),calc5+2
	move.w	(a1,d1.W),calc5+6
	move.w	(a2,d1.W),calc5+10
	move.w	(a2,d1.W),calc5+14
	move.w	(a1,d2.W),calc3+2
	move.w	(a1,d2.W),calc3+6
	move.w	(a2,d2.W),calc3+10
	move.w	(a2,d2.W),calc3+14

	lea	matrixpos+4(pc),a0
	lea	matrix_vectors(pc),a1
	moveq	#15,d5
	moveq	#2,d7
matrixloop
	movem.w	(a0),d0-d2
	move.w	d1,d4
	move.w	d0,d3
calc3	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d0
	muls	#$0000,d1
	sub.l	d4,d0
	add.l	d3,d1
	add.l	d0,d0
	add.l	d1,d1
	swap	d0
	swap	d1
	move.w	d2,d4
	move.w	d1,d3
calc4	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d1
	muls	#$0000,d2
	sub.l	d4,d1
	add.l	d3,d2
	add.l	d1,d1
	add.l	d2,d2
	swap	d1
	swap	d2
	move.w	d2,d4
	move.w	d0,d3
calc5	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d0
	muls	#$0000,d2
	sub.l	d4,d0
	add.l	d3,d2
	add.l	d0,d0
	add.l	d2,d2
	swap	d0
	swap	d2
	move.w	d2,12(a1)
	move.w	d1,6(a1)
	move.w	d0,(a1)+
	subq.l	#2,a0
	dbf	d7,matrixloop
	rts

* DATA *
matrixpos	dc.w 0,0,$4000,0,0
matrix_vectors	ds.w 9
mousexy		dc.w 0,0


*----------*
* DOT CALC *
*----------*
dotcalc:
	lea	vectorbuffer,a0
	lea	xy1buffer,a1

	clr.w	noprint
	move.l	strukturptr(pc),a2
	move.l	(a2),a2
	tst.b	(a2)
	beq.B	.facefound
	adda.w	#16,a0
	tst.b	8(a2)
	beq.B	.facefound
	move.w	#-1,noprint
.facefound

	movem.w	(a0),d5/d6
	movem.w	4(a0),d3/d4
	sub.w	d3,d5
	sub.w	d4,d6
	ext.l	d5
	ext.l	d6
	moveq	#10,d0
	asl.l	d0,d5
	asl.l	d0,d6
	ext.l	d3
	ext.l	d4
	swap	d3
	swap	d4
	moveq	#64/2-1,d7
.loop1	 REPT 2
	move.l	d3,d0
	move.l	d4,d1
	swap	d0
	swap	d1
	move.w	d0,(a1)+
	move.w	d1,(a1)+
	add.l	d5,d3
	add.l	d6,d4
	 ENDR
	dbf	d7,.loop1

	movem.w	12(a0),d5/d6
	movem.w	8(a0),d3/d4
	sub.w	d3,d5
	sub.w	d4,d6
	ext.l	d5
	ext.l	d6
	moveq	#10,d0
	asl.l	d0,d5
	asl.l	d0,d6
	ext.l	d3
	ext.l	d4
	swap	d3
	swap	d4
	moveq	#64/2-1,d7
.loop2	 REPT 2
	move.l	d3,d0
	move.l	d4,d1
	swap	d0
	swap	d1
	move.w	d0,(a1)+
	move.w	d1,(a1)+
	add.l	d5,d3
	add.l	d6,d4
	 ENDR
	dbf	d7,.loop2

	lea	xy1buffer,a0
	lea	xy2buffer,a1
	lea	ytabel,a2
	move.w	#64,counter
.calc1
	movem.w	(a0),d5/d6
	movem.w	[64*4](a0),d3/d4
	sub.w	d3,d5
	sub.w	d4,d6
	ext.l	d5
	ext.l	d6
	moveq	#10,d0
	asl.l	d0,d5
	asl.l	d0,d6
	ext.l	d3
	ext.l	d4
	swap	d3
	swap	d4
	moveq	#[64/4]-1,d7
.calc2	 REPT 4
	move.l	d3,d0
	move.l	d4,d1
	swap	d0
	swap	d1
	move.w	d0,d2
	not.b	d0
	lsr.w	#3,d2
	add.w	d1,d1
	add.w	(a2,d1.W),d2
	move.w	d0,(a1)+
	move.w	d2,(a1)+
	add.l	d5,d3
	add.l	d6,d4
	 ENDR
	dbf	d7,.calc2
	addq.l	#4,a0
	subq.w	#1,counter
	bne.W	.calc1

	tst.w	noprint
	beq.B	.dothedotman
	rts
.dothedotman
	lea	xy2buffer,a0
	move.l	display(pc),a1
	jsr	punishertabel
	rts
* DOT data
counter:	dc.w 0
noprint:	dc.w 0



*---------------------*
* MAKE PUNISHER TABEL *

maketabel:
	lea	punishertabel,a0
	lea	picture,a1
	move.w	#[64*8]-1,d7
.loop1	moveq	#7,d5
.loop2	move.w	#$3018,(a0)+
	move.w	#$3218,(a0)+
	btst	d5,(a1)
	beq.B	.col1
	move.l	#$01f11000,(a0)+
.col1	btst	d5,64*8(a1)
	beq.B	.col2
	move.l	#$01f11000+[width],(a0)+
.col2	btst	d5,64*8*2(a1)
	beq.B	.col3
	move.l	#$01f11000+[2*width],(a0)+
.col3	dbf	d5,.loop2
	addq.l	#1,a1
	dbf	d7,.loop1
	move.w	#$4e75,(a0)+
	rts


*----------------------*
* VECTOR STRUKTUR DATA *

box = 90
strukturptr: dc.l strk1
strk1:
 dc.l .data,.coords,0
 dc.w 0,0,0,800			;xyz and zoff-add
 dc.w 8,-10,10			;xyz-rot

.data:
 dc.b 0,4,0, 0,3,2,1,0
 dc.b 0,4,0, 4,5,6,7,4
 dc.b 0,4,14, 0,1,5,4,0
 dc.b 0,4,14, 2,3,7,6,2
 dc.b 0,4,15, 1,2,6,5,1
 dc.b 0,4,15, 3,0,4,7,3
 dc.b -1
 even
.coords
 dc.w box,box,-box,	box,-box,-box,	-box,-box,-box,	-box,box,-box
 dc.w box,box,box,	box,-box,box,	-box,-box,box,	-box,box,box
 dc.w $8000,$8000,$8000


*--------*
*  DATA  *
*--------*
intregs		ds.w 2
clrregs		blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800000
 dc.l $008e2861,$0090f3c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.l $01080000+[width*3],$010a0000+[width*3]
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000

 dc.l $01800000,$01820aaa,$01840222,$01860333
 dc.l $01880555,$018a0777,$018c0888,$018e0111
 dc.l $01900000,$01920aaa,$01940222,$01960333
 dc.l $01980555,$019a0777,$019c0036,$019e0035

 dc.l $4001fffe
 dc.l $01004200
copptrs
 dc.l $00e00005,$00e20000
 dc.l $00e40005,$00e60000
 dc.l $00e80005,$00ea0000
 dc.l $00ec0005,$00ee0000
 dc.l $f301fffe,$01000200
 dc.l $fffffffe

	DC.W	$0000,$0AAA,$0222,$0333,$0555,$0777,$0888,$0111

*-------------*
* SUBROUTINES *
*-------------*

RC:
;	move.w	#$a00,$180(a6)
	cmp.b	$6(a6),d0
	bne.B	RC
;	clr.w	$180(a6)
	rts

fill:	clr.l	(a0)+
	clr.l	(a0)+
	subq.l	#8,d0
	bpl.B	fill
	rts

 END

