; filled vector using copper to clear, draw and fill!
;								TAS / jul1991


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000
*  vectorscreens		$40000	$49000
*  tabels			$5e000	$64000

 include chipmap.inc
>extern "df0:sin1024.data",sintabel

 org $28000
 load $28000

width = 44

size = 200*width*5
screen1	= $40000
screen2	= screen1+size

copper1 = $60000
copper2 = $62000

ytabel		= $5e000
vectorbuffer	= $5e400
sintabel	= $2b000

matrixarea = $64000


BLTW:	 MACRO
.\@	btst	#14,$2(a6)
	bne.S	.\@
	 ENDM

*------------------*
* START UP PROGRAM *

s	lea	DMA,a6
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	move.w	#$01bf,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	clr.w	$180(a6)
	lea	$bfd100,a0
	bset	#7,(a0)
	and.b	#$87,(a0)
	ori.b	#$78,(a0)
	move.l	$4.W,a0
;;	clr.l	56(a0)	;Reset!

*-------
* SETUP

	lea	screen1,a0
	move.w	#$5600,d0
.clr	clr.l	(a0)+
	dbf	d0,.clr

	lea	copper1,a0
	move.w	#$1000,d0
.clr2	clr.l	(a0)+
	dbf	d0,.clr2

	lea	ytabel,a0
	moveq	#0,d0
	move.w	#255,d7
.ytab	move.w	d0,(a0)+
	addi.w	#width*5,d0
	dbf	d7,.ytab

	lea	matrixarea,a0
	moveq	#-128,d1
	move.w	#255,d7
.tab1	moveq	#-128,d2
	move.w	#255,d6
.tab2	move.w	d1,d0
	muls	d2,d0
	asr.w	#8,d0
	move.b	d0,(a0)+
	addq.w	#1,d2
	dbf	d6,.tab2
	addq.w	#1,d1
	dbf	d7,.tab1

	move.l	strukturptr(pc),a0
	move.l	4(a0),a0
.fact	move.w	(a0),d0
	lsl.w	#2,d0
	move.w	d0,(a0)+
	tst.w	(a0)
	bpl.B	.fact

	move.l	strukturptr(pc),a0
	move.l	8(a0),a0
.coord	move.w	(a0),d0
	lsl.w	#8,d0
	move.w	d0,(a0)+
	cmpi.w	#$8000,(a0)
	bne.S	.coord

	bsr.W	setupcopper

*-------------------------
* PREPARE COPPER, DMA ECT

	lea	CP(pc),a0
	move.l	a0,$80(a6)
	clr.w	$88(a6)
	move.w	#$83f0,DMACON(a6)
;	move.w	#$c020,INTENA(a6)
	move.w	#$0002,COPCON(a6)			;Turn on blittercop

*-----------------------*
*	MAIN LOOP	*

ML
	move.w	#$134,d0
	bsr.W	RC
	move.w	#$0400,$dff096

	lea	copdisplay(pc),a1
	move.l	4(a1),a6
	move.l	(a1),4(a1)
	move.l	a6,(a1)
	move.l	a6,$dff080

	bsr.B	filledvector

	move.w	#$8400,$dff096
;	move.l	#$00010000,(a6)+
;	move.l	#$01800fff,(a6)+
	moveq	#-2,d0
	move.l	d0,(a6)+

	btst	#6,$bfe001
	bne.B	ML

*------*
* EXIT *
	lea	DMA,a6
	move.w	#$0000,COPCON(a6)			;Turn off blittercop
	move.l	#$7fff7fff,INTENA(a6)
	move.l	intregs(pc),d0
	ori.l	#$80008000,d0
	move.l	d0,INTENA(a6)

	move.l	$4.W,a0
	move.l	$9c(a0),a0
	move.l	$26(a0),$80(a6)
	tas	$88(a6)
	move.w	#$83f0,DMACON(a6)
	moveq	#0,d0
	rts
copdisplay: dc.l copper1,copper2


*-----------------------
* filled vector routine

filledvector:
	lea	display(pc),a2
	movem.l	(a2),d0-d3
	movem.l	d2/d3,(a2)
	movem.l	d0/d1,8(a2)

	lea	copfill-CP(a6),a1
	adda.w	#CPx-CP,a6

	move.l	4(a2),a0
	tst.l	(a0)
	beq.B	.noclrmem
	move.w	(a0)+,2(a1)	;BLTDPT
	move.w	(a0)+,6(a1)
	move.w	(a0)+,10(a1)	;BLTDMOD
	move.w	(a0)+,14(a1)	;BLTSIZE
.noclrmem
	bsr.W	matrixcalc

	move.l	strukturptr(pc),a5
	move.l	8(a5),a0
	lea	vectorbuffer,a1
	lea	matrixarea+$8080,a3
	move.w	#168,a6
	move.w	#80,a4
calcloop
	movem.w	(a0)+,d0-d2
calc1	move.b	0(a3,d2.w),d5
	add.b	0(a3,d0.w),d5
	add.b	0(a3,d1.w),d5
	ext.w	d5
calc2	move.b	0(a3,d0.w),d3
	add.b	0(a3,d1.w),d3
	add.b	0(a3,d2.w),d3
	ext.w	d3
calc3	move.b	0(a3,d0.w),d4
	add.b	0(a3,d1.w),d4
	add.b	0(a3,d2.w),d4
	ext.w	d4
	add.w	a6,d3
	add.w	a4,d4
	move.w	d3,(a1)+
	move.w	d4,(a1)+
	move.w	d5,(a1)+
	addq.l	#2,a1
	cmpi.w	#$8000,(a0)
	bne.B	calcloop

	rts

	move.l	strukturptr(pc),a5
	bsr.W	polykill

	lea	printlines(pc),a0
	lea	vectorbuffer,a1
	move.l	4(a5),a2
	lea	edges(pc),a3
	lea	ytabel,a4
	moveq	#63,d7
	move.l	#$01500000,(a3)
	move.l	#$00c80000,4(a3)
.vecloop2
	move.b	(a0)+,color
	beq.B	.nope
	movem.w	(a2)+,d5/d6
	movem.w	(a1,d5.W),d0/d1
	movem.w	(a1,d6.W),d2/d3
	bsr.W	drawvector
.nope	dbf	d7,.vecloop2

	movem.w	(a3),d0-d3
	tst.w	d0
	bpl.B	.vecb1
	clr.w	d0
.vecb1	cmpi.w	#336,d1
	ble.B	.vecb2
	move.w	#336,d1
.vecb2	tst.w	d2
	bge.B	.vecb3
	clr.w	d2
.vecb3	cmpi.w	#200,d3
	ble.B	.vecb4
	move.w	#200,d3
.vecb4
	move.w	d3,d4
	mulu	#width*5,d4
	sub.w	d2,d3
	addq.w	#1,d3
	ble.B	.nofill
	mulu	#5,d3
	lsl.w	#6,d3
	lsr.w	#3,d0
	lsr.w	#3,d1
	add.w	d1,d4
	sub.w	d0,d1
	addq.w	#3,d1
	ble.B	.nofill
	lsr.w	#1,d1
	add.w	d1,d3
	add.w	d1,d1
	moveq	#width,d0
	sub.w	d1,d0
	move.l	display(pc),a0
	adda.l	d4,a0
	move.l	#$00010000,(a6)+
	move.l	#$004009f0,(a6)+
	move.l	#$00420012,(a6)+
	move.l	#$0044ffff,(a6)+
	move.l	#$0046ffff,(a6)+
	move.l	a0,d1
	swap	d1
	move.w	#BLTAPT,(a6)+
	move.w	d1,(a6)+
	move.w	#BLTAPT+2,(a6)+
	move.w	a0,(a6)+
	move.w	#BLTDPT,(a6)+
	move.w	d1,(a6)+
	move.w	#BLTDPT+2,(a6)+
	move.w	a0,(a6)+
	move.w	#BLTAMOD,(a6)+
	move.w	d0,(a6)+
	move.w	#BLTDMOD,(a6)+
	move.w	d0,(a6)+
	move.w	#BLTSIZE,(a6)+
	move.w	d3,(a6)+

	move.l	display+4(pc),a2
	move.l	a0,(a2)
	movem.w	d0/d3,4(a2)
.nofill
	rts

drawvector:
	cmp.w	d1,d3
	beq.W	noline
	bge.S	.vecexg
	exg	d0,d2
	exg	d1,d3
.vecexg	cmp.w	(a3),d0
	bgt.S	.vecb1
	move.w	d0,(a3)
.vecb1	cmp.w	(a3)+,d2
	bgt.S	.vecb2
	move.w	d2,-2(a3)
.vecb2	cmp.w	(a3),d0
	blt.S	.vecb3
	move.w	d0,(a3)
.vecb3	cmp.w	(a3)+,d2
	blt.S	.vecb4
	move.w	d2,-2(a3)
.vecb4	cmp.w	(a3)+,d1
	bgt.S	.vecb5
	move.w	d1,-2(a3)
.vecb5	cmp.w	(a3),d3
	blt.S	.vecb6
	move.w	d3,(a3)
.vecb6	subq.l	#6,a3

	cmp.w	d1,d3
	beq.W	noline
	move.w	d1,d4
	sub.w	d3,d4
	cmp.w	d0,d2
	beq.S	.draw4
	blo.S	.draw2
	move.w	d0,d5
	sub.w	d2,d5
	bra.S	.draw3
.vectorcontrol dc.b $01,$11,$09,$15,$05,$19,$0d,$1d
.draw2	move.w	d2,d5
	sub.w	d0,d5
.draw3	add.w	d4,d4
	cmp.w	d4,d5
	bhi.S	.draw4
	subq.w	#1,d3
.draw4	moveq	#0,d4
	move.w	d1,d4
	mulu	#width*5,d4
;	add.w	d4,d4
;	move.w	(a4,d4.W),d4
	moveq   #-16,d5
	and.w	d0,d5
	lsr.w	#3,d5
	add.w	d5,d4
	add.l	display(pc),d4
	moveq	#0,d5
	sub.w	d1,d3
	bge.S	.draw5
	neg.w	d3
.draw5	sub.w	d0,d2
	roxl.b	#1,d5
	tst.w	d2
	bge.S	.draw6
	neg.w	d2
.draw6	move.w	d3,d1
	sub.w	d2,d1
	bge.S	.draw7
	exg	d2,d3
.draw7	roxl.b	#1,d5
	move.b	.vectorcontrol(pc,d5.W),d5
	andi.w	#$f,d0
	ror.w	#4,d0
	ori.w	#$0b4a,d0
	add.w	d2,d2
	move.w	d2,d1
	sub.w	d3,d2
	bge.S	.draw8
	ori.b	#$40,d5
.draw8	ori.b	#3,d5
	move.w	d2,d6
	sub.w	d3,d2
	lsl.w	#6,d3
	addq.w	#2,d3
	move.l	#$00010000,(a6)+
	move.w	#$62,(a6)+
	move.w	d1,(a6)+
	move.w	#$64,(a6)+
	move.w	d2,(a6)+

	move.b	color(pc),d1
	btst	#0,d1
	beq.S	.col1
	move.w	#$40,(a6)+
	move.w	d0,(a6)+
	move.w	#$42,(a6)+
	move.w	d5,(a6)+
	move.w	#$52,(a6)+
	move.w	d6,(a6)+
	move.w	#$4a,(a6)+
	move.w	d4,(a6)+
	move.w	#$56,(a6)+
	move.w	d4,(a6)+
	swap	d4
	move.w	#$48,(a6)+
	move.w	d4,(a6)+
	move.w	#$54,(a6)+
	move.w	d4,(a6)+
	swap	d4
	move.w	#$58,(a6)+
	move.w	d3,(a6)+

.col1	addi.l	#width,d4
	btst	#1,d1
	beq.S	.col2
	move.l	#$00010000,(a6)+
	move.w	#$40,(a6)+
	move.w	d0,(a6)+
	move.w	#$42,(a6)+
	move.w	d5,(a6)+
	move.w	#$52,(a6)+
	move.w	d6,(a6)+
	move.w	#$4a,(a6)+
	move.w	d4,(a6)+
	move.w	#$56,(a6)+
	move.w	d4,(a6)+
	swap	d4
	move.w	#$48,(a6)+
	move.w	d4,(a6)+
	move.w	#$54,(a6)+
	move.w	d4,(a6)+
	swap	d4
	move.w	#$58,(a6)+
	move.w	d3,(a6)+

.col2	addi.l	#width*2,d4
	btst	#3,d1
	beq.S	.col3
	move.l	#$00010000,(a6)+
	move.w	#$40,(a6)+
	move.w	d0,(a6)+
	move.w	#$42,(a6)+
	move.w	d5,(a6)+
	move.w	#$52,(a6)+
	move.w	d6,(a6)+
	move.w	#$4a,(a6)+
	move.w	d4,(a6)+
	move.w	#$56,(a6)+
	move.w	d4,(a6)+
	swap	d4
	move.w	#$48,(a6)+
	move.w	d4,(a6)+
	move.w	#$54,(a6)+
	move.w	d4,(a6)+
	swap	d4
	move.w	#$58,(a6)+
	move.w	d3,(a6)+
.col3
	addi.l	#width,d4
	btst	#4,d1
	beq.S	noline
	move.l	#$00010000,(a6)+
	move.w	#$40,(a6)+
	move.w	d0,(a6)+
	move.w	#$42,(a6)+
	move.w	d5,(a6)+
	move.w	#$52,(a6)+
	move.w	d6,(a6)+
	move.w	#$4a,(a6)+
	move.w	d4,(a6)+
	move.w	#$56,(a6)+
	move.w	d4,(a6)+
	swap	d4
	move.w	#$48,(a6)+
	move.w	d4,(a6)+
	move.w	#$54,(a6)+
	move.w	d4,(a6)+
	swap	d4
	move.w	#$58,(a6)+
	move.w	d3,(a6)+
noline	rts


polykill:
	lea	printlines(pc),a3
	move.l	a3,a0
	moveq	#0,d0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+

	lea	vectorbuffer,a0
	movem.l	(a5),a1/a2
.loop	move.b	#1,(a1)
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	move.b	3(a1),d0
	move.b	4(a1),d1
	move.b	5(a1),d2
	lsl.w	#2,d0
	lsl.w	#2,d1
	lsl.w	#2,d2
	move.w	(a2,d0.W),d0
	move.w	(a2,d1.W),d1
	move.w	(a2,d2.W),d2
	movem.w	(a0,d1.W),d3/d4
	movem.w	(a0,d2.W),d5/d6
	movem.w	(a0,d0.W),d0/d1
	sub.w	d3,d0
	sub.w	d4,d1
	sub.w	d3,d5
	sub.w	d4,d6
	muls	d1,d5
	muls	d0,d6
	addq.l	#1,a1
	moveq	#0,d0
	move.b	(a1)+,d0
	subq.w	#1,d0
	move.b	(a1)+,d1
	sub.l	d6,d5
	bpl.S	.front
	lsl.w	#3,d1
.front	moveq	#0,d2
.print	move.b	(a1)+,d2
	eor.b	d1,(a3,d2.W)
	dbf	d0,.print
	tst.b	(a1)
	bpl.S	.loop
	rts

* DATA *
display		dc.l screen1,edges+8,screen2,edges+16
printlines:	ds.b 64
color		dc.b 0
 even
vectorxy	dc.w 0,0,0

edges		dc.w 336,0,200,0
		dc.l 0,0, 0,0, 0,0

*-------------
* matrix calc

matrixcalc:
	lea	vectorstore,a0
	lea	vectorxy(pc),a4
	lea	sintabel,a2
	lea	256(a2),a1

	movem.w	(a4),d0-d2
	addq.w	#2,d0
	subq.w	#2,d1
	addq.w	#2,d2
	and.w	#$3fe,d0
	and.w	#$3fe,d1
	and.w	#$3fe,d2
	movem.w	d0-d2,(a4)

	move.w	(a2,d0.W),$1e(a0)
	move.w	(a2,d1.W),$20(a0)
	move.w	(a2,d2.W),$22(a0)
	move.w	(a1,d0.W),$24(a0)
	move.w	(a1,d1.W),$26(a0)
	move.w	(a1,d2.W),$28(a0)
	move.w	30(a0),d0
	move.w	d0,d1
	muls	32(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,$0012(a0)
	move.w	d1,d0
	muls	40(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,$0014(a0)
	move.w	d1,d0
	muls	$0022(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,26(a0)
	move.w	$0024(a0),d0
	move.w	d0,d1
	muls	$0022(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,$0016(a0)
	move.w	d1,d0
	muls	40(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,24(a0)
	move.w	d1,d0
	muls	32(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,$001c(a0)
	move.w	$0026(a0),d0
	move.w	d0,d1
	muls	40(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,(a0)
	muls	$0022(a0),d1
	add.l	d1,d1
	swap	d1
	move.w	d1,2(a0)
	move.w	32(a0),d0
	neg.w	d0
	move.w	d0,4(a0)
	move.w	$0012(a0),d0
	move.w	d0,d1
	muls	40(a0),d0
	add.l	d0,d0
	swap	d0
	sub.w	$0016(a0),d0
	move.w	d0,6(a0)
	muls	$0022(a0),d1
	add.l	d1,d1
	swap	d1
	add.w	24(a0),d1
	move.w	d1,8(a0)
	move.w	30(a0),d0
	muls	$0026(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,10(a0)
	move.w	$001c(a0),d0
	move.w	d0,d1
	muls	40(a0),d0
	add.l	d0,d0
	swap	d0
	add.w	26(a0),d0
	move.w	d0,12(a0)
	muls	$0022(a0),d1
	add.l	d1,d1
	swap	d1
	sub.w	$0014(a0),d1
	move.w	d1,14(a0)
	move.w	$0024(a0),d0
	muls	$0026(a0),d0
	add.l	d0,d0
	swap	d0
	move.w	d0,16(a0)

	lea	calc2(pc),a1
	move.w	(a0),d0
	asr.w	#8,d0
	move.b	d0,3(a1)
	move.w	2(a0),d0
	asr.w	#8,d0
	move.b	d0,7(a1)
	move.w	4(a0),d0
	asr.w	#8,d0
	move.b	d0,11(a1)

	lea	calc3(pc),a1
	move.w	6(a0),d0
	asr.w	#8,d0
	move.b	d0,3(a1)
	move.w	8(a0),d0
	asr.w	#8,d0
	move.b	d0,7(a1)
	move.w	10(a0),d0
	asr.w	#8,d0
	move.b	d0,11(a1)

	lea	calc1(pc),a1
	move.w	12(a0),d0
	asr.w	#8,d0
	move.b	d0,7(a1)
	move.w	14(a0),d0
	asr.w	#8,d0
	move.b	d0,11(a1)
	move.w	16(a0),d0
	asr.w	#8,d0
	move.b	d0,3(a1)
	rts


* DATA *
vectorstore:
	dcb.w 21,0
	dc.w 0,0,0




*----------------------*
* VECTOR STRUKTUR DATA *

boxsize = 40

strukturptr: dc.l strk1
strk1:
 dc.l .data,.lines,.coords
 dc.w 0,0,0,800			;xyz and zoff-add
 dc.w 4,-4,4			;xyz-rot

.data:
 dc.b 0,4,3, 5,10,1,8
 dc.b 0,4,3, 7,9,3,11
 dc.b 0,4,2, 0,1,2,3
 dc.b 0,4,2, 7,6,5,4
 dc.b 0,4,1, 9,4,8,0
 dc.b 0,4,1, 10,6,11,2
 dc.b -1
 even
.lines
 dc.w 0,1, 1,2, 2,3, 3,0
 dc.w 4,5, 5,6, 6,7, 7,4
 dc.w 1,5, 0,4, 2,6, 3,7
 dc.w -1
.coords
 dc.w boxsize,boxsize,-boxsize,		boxsize,-boxsize,-boxsize
 dc.w -boxsize,-boxsize,-boxsize,	-boxsize,boxsize,-boxsize
 dc.w boxsize,boxsize,boxsize,		boxsize,-boxsize,boxsize
 dc.w -boxsize,-boxsize,boxsize,	-boxsize,boxsize,boxsize
 dc.w $8000,$8000,$8000



*--------*
*  DATA  *
*--------*
intregs		ds.w 2
clrregs		blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800000
 dc.l $008e5061,$0090f0c1,$00920030,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.l $01080002+[width*4],$010a0002+[width*4]
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
copptrs:
 dc.l $00e00004,$00e20000
 dc.l $00e40004,$00e60000
 dc.l $00e80004,$00ea0000
 dc.l $00ec0004,$00ee0000
 dc.l $00f00004,$00f20000

 dc.l $01005200

 dc.l $00010000
 dc.w BLTCON0,$0100
 dc.w BLTCON1,$0002
 dc.w BLTAFWM,-1
 dc.w BLTALWM,-1
copfill:
 dc.w BLTDPT,screen1/$10000
 dc.w BLTDPT+2,screen1&$ffff
 dc.w BLTDMOD,0
 dc.w BLTSIZE,1<<6+1

 dc.l $00010000
 dc.l $0044ffff
 dc.l $0072ffff
 dc.l $00748000
 dc.w $0048,screen1/$10000
 dc.w $0054,screen1/$10000
 dc.w $0060,width*5
 dc.w $0066,width*5
CPx:
 dc.l $01800000,$0182000E,$0184000D,$0186000C	;%00000
 dc.l $01880FFF,$018a0FFF,$018c0FFF,$018e0FFF	;%00100
 dc.l $01900F00,$01920F0E,$01940F0D,$01960F0C	;%01000
 dc.l $01980F00,$019a0F0E,$019c0F0D,$019e0F0C	;%01100
 dc.l $01a00E00,$01a20E0E,$01a40E0D,$01a60E0C	;%10000
 dc.l $01a80D00,$01aa0D0E,$01ac0D0D,$01ae0D0C	;%10100
 dc.l $01b00C00,$01b20C0E,$01b40C0D,$01b60C0C	;%11000
 dc.l $01b80F00,$01ba0F0E,$01bc0F0D,$01be0F0C	;%11100	(dots)
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*

RC:
;	move.w	#$a00,$dff180
	move.l	$dff004,d1
	lsr.l	#1,d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$dff180
	rts

fill:	BLTW
	move.l	#$01000000,$40(a6)
	clr.l	$44(a6)
	clr.w	$66(a6)
	move.l	a0,$54(a6)
	lsr.l	#1,d0
	move.w	d0,$58(a6)
	BLTW
	rts

*------------------------*
* COPPER / BLITTER SETUP *

setupcopper:
	lea	copper1,a4
	lea	copper2,a5
	lea	CP(pc),a0
	lea	CPx(pc),a1
.copy	move.l	(a0),(a4)+
	move.l	(a0)+,(a5)+
	cmpa.l	a0,a1
	bne.S	.copy

	lea	copper1+[copptrs-CP],a0
	lea	screen2,a1
	bsr.B	copins2
	lea	copper2+[copptrs-CP],a0
	lea	screen1,a1
	bsr.B	copins2
	rts

copins2	move.l	a1,d0
	swap	d0
	move.w	d0,2(a0)
	move.w	a1,6(a0)
	adda.w	#width,a1
	addq.l	#8,a0
	move.l	a1,d0
	swap	d0
	move.w	d0,2(a0)
	move.w	a1,6(a0)
	adda.w	#width,a1
	addq.l	#8,a0
	move.l	a1,d0
	swap	d0
	move.w	d0,2(a0)
	move.w	a1,6(a0)
	adda.w	#width,a1
	addq.l	#8,a0
	move.l	a1,d0
	swap	d0
	move.w	d0,2(a0)
	move.w	a1,6(a0)
	adda.w	#width,a1
	addq.l	#8,a0
	move.l	a1,d0
	swap	d0
	move.w	d0,2(a0)
	move.w	a1,6(a0)
	adda.w	#width,a1
	addq.l	#8,a0
	rts

 END

